{+doc
+NOMBRE: ucntrl
+CREACION: 30.06.96
+AUTORES: rch
+REGISTRO:
+TIPO: Unidad Pascal.
+PROPOSITO: Definicin de ventana de control de un parmetro para
	Simeep.


+PROYECTO: Simeep.

+REVISION:
+AUTOR:
+DESCRIPCION:
-doc}


unit ucntrl;
interface
uses
   Graphics, Forms,
	wtraxp, {wRCHFONTS,} Classes, SysUtils,
	xMatDefs, FilUsr, DIBUS, Raton, teclado, variable;


const
	interlineado: NReal= 1;
	ColorTexto: word= Amarillo;
	ticsvisualizacion:integer=50; {valor de conteo para desborde de}
											{contador de captura de visualizacion}
											{de variables}

var
   MargenTexto, MargenTextoDer, AltoRenglon, MargenYSup: integer;
   AnchoLetra, AltoLetra: integer;


type
	{seales de aviso para el objeto PCtrlBoton}
	TMouseEvent = (
		BotonIzqAbajo, BotonIzqArriba,
		Arrivo, Abandono, Movimiento,
		BotonDerAbajo, BotonDerArriba
		);

type

	PCtrl= ^TCtrl;
	TCtrl= object { Genrico. }
		LetraControl: char;
		renglon: integer;
		texto1, texto2: string;
		campo: integer;
      nRenglones: integer;

		constructor Init(
			xLetraControl: char;
			xrenglon: integer;
			xtexto1: string;
			xtexto2: string;
			xCampo: integer); { nmero de caracteres del intertexto }
		destructor done; virtual;
		procedure ActuarOnKey( Letra: char ); virtual;
		procedure ActuarOnMouse( MouseEvent: TMouseEvent ); virtual;
		procedure WriteTxt( texto: string ); virtual;
		procedure Pintar; virtual;
		procedure Incrementar; virtual;
		procedure Decrementar; virtual;
		function TocadoXY( x, y: integer): boolean; virtual;
      procedure CajaControl;
      procedure CajaDisplay( nf, nc, lc: integer;
                              xtexto1, xtextoCentro, xtexto2: string;
                              ColorFondoDisplay, ColorTintaDisplay: TColor;
                              SoloRefrescarCentro: boolean );
      procedure CajaInsignia( nf, nc: integer; xtexto: string );
      procedure CajaInsignia_ON( nf, nc: integer; xtexto: string );
      function CajaInsigniaTocadoXY(nf, nc: integer; xtexto: string; x, y: integer): boolean;
	end;



	PCtrlTexto = ^TCtrlTexto;
	TCtrlTexto = object( TCtrl )
	 constructor Init(
			xrenglon: integer;
			xtexto1: string);
		procedure WriteTxt( texto: string ); virtual;
	end;



	PCtrlVerTexto = ^TCtrlVerTexto;
	TCtrlVerTexto = object( TCtrl )
	constructor Init(
			xrenglon: integer;
			Texto_Arriba,Texto_Medio,Texto_Abajo: string);
	procedure WriteTxt( texto: string ); virtual;
	procedure Pintar; virtual;
	end;

	PCtrlVer2Var= ^TCtrlVer2Var;
	TCtrlVer2Var= object( TCtrl )
		texto3,texto4:string;
		decimales1,decimales2:integer;
		valor_mostrado1, valor_mostrado2:NReal;
		pvar1, pvar2:PNReal;
		constructor Init(
			xrenglon: integer;
			xtexto11: string;
			xtexto12: string;
			xDecimales1: integer;
			var Variable1: NReal;
			xtexto21: string;
			xtexto22: string;
			xDecimales2: integer;
			var Variable2: NReal);
		procedure ActuarOnKey( Letra: char ); virtual;
		procedure WriteTxt( texto: string ); virtual;
	end;

	PCtrlBoton = ^TCtrlBoton;
	TCtrlBoton = object( TCtrl )
		xproc:ExtProc;
		Apretado: boolean;
		xx1,yy1,xx2,yy2:integer;
		constructor Init(
			nxx1,nyy1,nxx2,nyy2:integer;
			xtexto1: string;
			nxproc:ExtProc);
		procedure WriteTxt( texto: string ); virtual;
		procedure Paint; virtual;
		procedure ActuarOnMouse( MouseEvent: TMouseEvent ); virtual;
		function TocadoXY( x, y: integer ): boolean; virtual;
	end;


	PCtrlBotonVar = ^TCtrlBotonVar;
	TCtrlBotonVar = object(TCtrlBoton)
		valor:NReal;
		factor:NReal;		{factor que depende de la unidad seleccionada M,k,m,u,n o p}
		desplazamiento:integer;
		boton:integer;	{0 boton izquierdo; 1 derecho}
		pvar:PNReal;
		deci:integer;
		min,
		max,
		def,
		incr:NReal;
		constructor Init(
			xrenglon:integer;
			xtexto1,
			xtexto2:string;
			xdeci:integer;
			xmin,
			xmax,
			xdef,
			xincr:NReal;
			var VariableControlada:NReal);
		procedure WriteTxt( texto: string ); virtual;
		procedure Paint; virtual;
		procedure ActuarOnMouse( MouseEvent: TMouseEvent ); virtual;
		function TocadoXY( x, y: integer ): boolean; virtual;
		procedure Incrementar; virtual;
		procedure Decrementar; virtual;
	end;


	PCtrlBotonVar2 = ^TCtrlBotonVar2;
	TCtrlBotonVar2 = object(TCtrlBotonVar)
		pmin,pmax:PNReal;
		constructor Init(
			xrenglon:integer;
			xtexto1,
			xtexto2:string;
			xdeci:integer;
			var xmin,xmax:NReal;
			xdef,
			xincr:NReal;
			var VariableControlada:NReal);
		procedure ActuarOnKey( Letra: char ); virtual;
		procedure Incrementar; virtual;
		procedure Decrementar; virtual;
	end;


	PCtrlBotonProc = ^TCtrlBotonProc;
	TCtrlBotonProc = object(TCtrlBoton)
		constructor Init(
			xrenglon:integer;
			xtexto1: string;
			nxproc:ExtProc);
	end;


	PCtrlNRealInc= ^TCtrlNRealInc;
	TCtrlNRealInc= object( TCtrl )
		Decimales: integer;
		MinVal, MaxVal, DefVal, IncVal: NReal;
		pvar: PNReal;

		constructor Init(
			xLetraControl: char;
			xrenglon: integer;
			xtexto1: string;
			xtexto2: string;
			xCampo, xDecimales: integer;
			xMinVal, xMaxVal, xDefVal, xIncVal: NReal;
			var VariableControlada: NReal	);
		procedure Pintar; virtual;
		procedure Incrementar; virtual;
		procedure Decrementar; virtual;
	end;


	PDsplyNReal= ^TDsplyNReal;
	TDsplyNReal= object( TCtrlNRealInc )
		constructor Init(
			xrenglon: integer;
			xtexto1: string;
			xtexto2: string;
			xCampo, xDecimales: integer;
			var VariableControlada: NReal	);
		procedure ActuarOnKey( Letra: char ); virtual;
		procedure WriteTxt( texto: string ); virtual;
	end;


	PCtrlNRealFac= ^TCtrlNRealFac;
	TCtrlNRealFac= object( TCtrlNRealInc )
		constructor Init(
			xLetraControl: char;
			xrenglon: integer;
			xtexto1: string;
			xtexto2: string;
			xCampo, xDecimales: integer;
			xMinVal, xMaxVal, xDefVal, xFacVal: NReal;
			var VariableControlada: NReal	);
		procedure Incrementar; virtual;
		procedure Decrementar; virtual;
	end;


	PCtrlNEntero= ^TCtrlNEntero;
	TCtrlNEntero= object( TCtrl )
		MinVal, MaxVal, DefVal, IncVal: NEntero;
		pvar: PNEntero;

		constructor Init(
			xLetraControl: char;
			xrenglon: integer;
			xtexto1: string;
			xtexto2: string;
			xCampo: integer;
			xMinVal, xMaxVal, xDefVal, xIncVal: NEntero;
			var VariableControlada: NEntero	);
		procedure Pintar; virtual;
		procedure Incrementar; virtual;
		procedure Decrementar; virtual;
	end;


	PDsplyNEntero= ^TDsplyNEntero;
	TDsplyNEntero= object( TCtrlNEntero )
		constructor Init(
			xrenglon: integer;
			xtexto1: string;
			xtexto2: string;
			xCampo: integer;
			var VariableControlada: NEntero	);
		procedure ActuarOnKey( Letra: char ); virtual;
		procedure WriteTxt( texto: string ); virtual;
	end;


	PCtrlBoolean= ^TCtrlBoolean;
	TCtrlBoolean= object( TCtrl )
		pvar: ^boolean;

		constructor Init(
				xLetra: char;
				xrenglon: integer;
				xtexto1: string;
				var xvar: boolean );

		procedure Pintar; virtual;
		procedure Incrementar; virtual;
		procedure Decrementar; virtual;

	end;

	PCtrlToggle= ^TCtrlToggle;
	TCtrlToggle= object( TCtrlBoolean )
		constructor Init(
				xLetra: char;
				xrenglon: integer;
				xtexto1: string;
				var xvar: boolean );
		procedure Incrementar; virtual;
		procedure Decrementar; virtual;
	end;


	PCtrlProcedure= ^TCtrlProcedure;
	TCtrlProcedure= object( TCtrl )
		proc: ExtProc;

		constructor Init(
				xLetra: char;
				xrenglon: integer;
				xtexto1: string;
				xproc: ExtProc );

		procedure Pintar; virtual;
		procedure Incrementar; virtual;
		procedure Decrementar; virtual;

	end;


	TControles= object
      cc:  TList;
		PActivo: PCtrl;
		constructor Init;
		procedure ActuarOnKey( Letra: char ); virtual;
		procedure ActuarOnMouse(x, y: integer; Evento: TMouseEvent ); virtual;
		function PTocadoXY(x, y: integer ): PCtrl;
		procedure Pintar;
	end;





procedure Init;
procedure Insert( p: pointer );
procedure InsertDisplay( p: pointer );


implementation



var
	UsrPesca, UsrInicio: ExtProc;
	Controles, Displays: TControles;
	I:INTEGER;

{Estado del MOUSE}
	xx, yy: word;
	izquierda, centro, derecha: boolean;

{para implementar la pausa en el procedimiento UCTRLpesca}
	PAUSA:boolean;

{para forzar la visualizacion de variables}
	contador:integer;


procedure Insert( p: pointer );
begin
	Controles.cc.Add(p);
end;

procedure InsertDisplay( p: pointer );
begin
	Displays.cc.add(p);
end;

procedure UCntrlInicio; far;
begin
	UsrInicio;
	Controles.Pintar;
	Displays.Pintar;
end;

procedure Ppausa; far;
begin
   pausa:= not pausa;
   beep;
end;

procedure psalir; far;
begin
   pausa:= false;
   variable.Terminar:= true;
   beep;
end;

procedure creditos; far;
begin
	beep;
	poner_ventana_creditos;
end;

procedure UCntrlPesca; far;
var
	tecla: char;
	x,y: word;
	izq, cnt, der: boolean;
	ocurrio_pausa:boolean;
	color_de_fondo:word;

begin
   application.ProcessMessages;
   UsrPesca;
	pausa:=false;
	ocurrio_pausa:=false;
	repeat {bucle de pausa}
		{forzar visualizaciones}
		contador:=contador+1;
		if contador>ticsvisualizacion then contador:=0;

		if contador=ticsvisualizacion then
		begin
			Displays.ActuarOnKey(tecla);
		end;

		if keypressed then
		begin
			tecla:= readkey;
			Controles.ActuarOnKey(tecla);
		end
		else
			{ Hacemos esto para que los controles que admiten se cambie su
			  valor externamente, funcionen}
			Controles.ActuarOnKey('');	{ESTE CARACTER NO SE PUEDE USAR COMO CONTROL}

		 LEER_RATON(x,y, izq, cnt, der);

		 if (x <> xx) or (y <> yy ) then
			Controles.ActuarOnMouse( x, y, Movimiento );

		 if izq <> izquierda then
			if izq then Controles.ActuarOnMouse( x, y, BotonIzqAbajo )
			else Controles.ActuarOnMouse( x, y, BotonIzqArriba );

		 if der <> derecha then
			if der then Controles.ActuarOnMouse( x, y, BotonDerAbajo )
			else Controles.ActuarOnMouse( x, y, BotonDerArriba );

		 xx:= x; yy:= y; izquierda:= izq; centro:= cnt; derecha:= der;

		if pausa then			{liberar al raton a toda la pantalla}
		begin
			ocurrio_pausa:=true;
			RANGO_FILA(7,465);
			RANGO_COLUMNA(5,625);
         application.ProcessMessages;
		end;
	until not pausa;

	if ocurrio_pausa then	 {reponer los limites del raton al area de control}
	begin
		RANGO_FILA(7,465);
		RANGO_COLUMNA(490,625);
	end;
end;


procedure Init;
begin
//INICIEGR;

   AltoLetra:= wtraxp.TextHeight('H');
   AnchoLetra:= wtraxp.TextWidth('M');
   AltoRenglon:= AltoLetra+4;
   MargenTexto:= wtraxp.GetMaxX -AreaTexto_lx+ 2*AnchoLetra ;
   MargenTextoDer:= wtraxp.GetMaxX - 2*AnchoLetra ;
   MargenYSup:= AltoLetra* 6;

   DIBUJO_CONTROL_BOTONERA( AreaTexto_lx-AnchoLetra );

   INICIALIZAR_RATON;

	Controles.Init;
	Displays.init;
	UsrPesca:= FilUsr.Pesca;
	FilUsr.Pesca:= UCntrlPesca;
	UsrInicio:= FilUsr.Inicio;
	FilUsr.Inicio:= UCntrlInicio;

  {logotipo}
  UCntrl.insert( new(PCtrlBoton,
      Init(
         MargenTexto, AltoLetra*2,
         MargenTextoDer,AltoLetra*5,
         '',creditos)));

  {botones de pausa y salir}
  UCntrl.insert( new(PCtrlBoton, Init(MargenTexto+2, GetMaxY - 2* AltoRenglon,MargenTexto+54,GetMaxY - AltoRenglon,'PAUSA',Ppausa)));
  UCntrl.insert( new(PCtrlBoton, Init(MargenTexto+67,GetMaxY - 2* AltoRenglon,MargenTexto+121,GetMaxY- AltoRenglon,'SALIR',psalir)));
end;



constructor	TCtrl.Init(
	xLetraControl: char;
			xrenglon: integer;
			xtexto1: string;
			xtexto2: string;
			xCampo: integer); { nmero de caracteres del intertexto }
begin
	LetraControl:= UpCase(xLetraControl);
	renglon:= xrenglon+3;	{no solapar con boton SIMEEP}
	texto1:= xtexto1;
	texto2:= xtexto2;
	campo:= xcampo;
   nRenglones:= 1;
end;

procedure TCtrl.ActuarOnMouse( MouseEvent: TMouseEvent );
begin
end;

function TCtrl.TocadoXY( x, y: integer): boolean;
begin
	TocadoXY:= false;
end;

procedure TCtrl.WriteTxt(texto: string );

var
	vp:ViewPortType;
	t:TextSettingsType;
	x1, x2, y1, y2: integer;
	OldColor: word;
   OldColorPapel: TColor;
begin

	Texto:= LetraControl+') '+texto;
	GetTextSettings(t);
	SetTextStyle(t.font,HorizDir,t.CharSize);
	SetTextJustify(just_Izquierda, Just_Abajo);

	x1:= GetMaxY+TextWidth('M')*3;
	x2:= x1+TextWidth( texto );
	y1:= trunc((renglon*interlineado)*TextHeight('H'));
	y2:= y1-TextHeight('H');

	GetViewSettings(vp);
	SetViewPort(x1, y2, x2, y1, true);
	ClearViewPort;

	with vp do  SetViewPort(x1,y1,x2,y2, true);
	OldColor:= GetColor;
	SetColor( ColorTexto );
	OutTextXY( x1, y1, texto);
	SetColor( OldColor);
	SetTextStyle(t.font,t.Direction,t.CharSize);
	SetTextJustify(t.Horiz,t.Vert);
end;

procedure TCtrl.Pintar;
var
	s: string;
	k: integer;
begin
	s:= texto1;
	for k:= 1 to campo do s:= s+' ';
	s:= s+texto2;
	WriteTXT( s);
end;

procedure TCtrl.ActuarOnKey( Letra: char );
begin
	if upCase(letra)= LetraControl then
	begin
		if upCase(Letra)= Letra then incrementar
		else decrementar;
	end;
end;

procedure TCtrl.Incrementar;
begin
	Pintar;
end;

procedure TCtrl.Decrementar;
begin
	Pintar;
end;

procedure TCtrl.CajaControl;
begin
	 SetFillStyle(bsSolid,GrisOscuro);  {.fondo gris.}
    SetColor( clblack );
	 Bar(MargenTexto - 3,RENGLON*AltoRenglon+MargenYSup-3, MargenTextoDer+3,(RENGLON+nRenglones)*AltoRenglon+MargenYSup+3);
						  {.marco_todo.}
	 MARCO_DESNIVEL(MargenTexto - 4,RENGLON*AltoRenglon+MargenYSup-1, MargenTextoDer+1,(RENGLON+nRenglones)*AltoRenglon+MargenYSup+2,0,15);
	 MARCO_DESNIVEL(MargenTexto - 3,RENGLON*AltoRenglon+MargenYSup, MargenTextoDer,(RENGLON+nRenglones)*AltoRenglon+MargenYSup+2,0,15);

end;

procedure TCtrl.CajaDisplay(
   nf, nc, lc: integer;
   xtexto1, xtextoCentro, xtexto2: string;
   ColorFondoDisplay, ColorTintaDisplay: TColor;
   SoloRefrescarCentro: boolean );
var
   x1, y1, x2, y2: integer;
begin

   x1:= MargenTexto + (nc-1)* AnchoLetra;
   y1:= (RENGLON+nf-1)*AltoRenglon+MargenYSup+2;
   x2:= x1 +lc * AnchoLetra;
   y2:= y1 + AltoRenglon-2;
	SetTextStyle(Fonts[2],0, xFontSize);

   if not SoloRefrescarCentro then
   begin
     SetFillStyle(bsSolid, ColorFondoDisplay); {.pinto display.}
     Bar( x1,y1,x2,y2 );
     MARCO_DESNIVEL( x1, y1, x2, y2, 0,15);

     wTraxp.ColorPapelTexto:= GrisOscuro;
     SetColor(  Negro );
     OutTextXY( MargenTexto , y1+2, xtexto1);
     OutTextXY( x2+4, y1+2, xtexto2);
   end;

   wTraxp.ColorPapelTexto:= ColorFondoDisplay;
	SetColor(  ColorTintaDisplay );
   OutTextXY( MargenTexto+ (nc-1)*AnchoLetra+1 , y1 +2 , xtextoCentro );
end;


function TCtrl.CajaInsigniaTocadoXY(nf, nc: integer; xtexto: string; x, y: integer): boolean;
var
   x1, y1, x2, y2: integer;
begin
   x1:= MargenTexto + (nc-1)* AnchoLetra+2;
   y1:= (RENGLON+nf-1)*AltoRenglon+MargenYSup+2;
   x2:= x1 + Length( xtexto ) * AnchoLetra-2;
   y2:= y1 + AltoRenglon-2;
	result:= (x1<=x)and(x<=x2)and(y1<=y)and(y<=y2);
end;

procedure TCtrl.CajaInsignia( nf, nc: integer; xtexto: string );
var
   x1, y1, x2, y2: integer;
begin
   x1:= MargenTexto + (nc-1)* AnchoLetra+2;
   y1:= (RENGLON+nf-1)*AltoRenglon+MargenYSup+2;
   x2:= x1 + Length( xtexto ) * AnchoLetra-2;
   y2:= y1 + AltoRenglon-2;
   ColorPapelTexto:= grisOscuro;
	INSIGNIA(x1,y1,xtexto,x2-x1,y2-y1);
end;

procedure TCtrl.CajaInsignia_ON( nf, nc: integer; xtexto: string );
var
   x1, y1, x2, y2: integer;
begin
   x1:= MargenTexto + (nc-1)* AnchoLetra+2;
   y1:= (RENGLON+nf-1)*AltoRenglon+MargenYSup+2;
   x2:= x1 + Length( xtexto ) * AnchoLetra-2;
   y2:= y1 + AltoRenglon-2;
	INSIGNIA_ON(x1,y1,xtexto,x2-x1,y2-y1);
end;


destructor TCtrl.done;
begin
end;

{ Mtodos de TCtrlNRealInc }

constructor TCtrlNRealInc.Init(
			xLetraControl: char;
			xrenglon: integer;
			xtexto1: string;
			xtexto2: string;
			xCampo, xDecimales: integer;
			xMinVal, xMaxVal, xDefVal, xIncVal: NReal;
			var VariableControlada: NReal	);
begin
	TCtrl.init(	xLetraControl,xrenglon,xtexto1,xtexto2,xCampo);
	Decimales:= xDecimales;
	MinVal:= xMinVal;
	MaxVal:= xMaxVal;
	DefVal:= xDefVal;
	IncVal:= xIncVal;
	pvar:= @VariableControlada;
end;

procedure TCtrlNRealInc.Pintar;
var
	s: string;
	k: integer;
begin
	str( pvar^:Campo:Decimales, s);
	s:= texto1+s+ texto2;
	writetxt( s);
end;

procedure TCtrlNRealInc.Incrementar;
begin
	pvar^:= pvar^+IncVal;
	if pvar^>MaxVal then pvar^:=MaxVal;
	Pintar;
end;

procedure TCtrlNRealInc.Decrementar;
begin
	pvar^:= pvar^-IncVal;
	if pvar^<MinVal then pvar^:=MinVal;
	Pintar;
end;




constructor TCtrlNRealFac.Init(
			xLetraControl: char;
			xrenglon: integer;
			xtexto1: string;
			xtexto2: string;
			xCampo, xDecimales: integer;
			xMinVal, xMaxVal, xDefVal, xFacVal: NReal;
			var VariableControlada: NReal	);
begin
	TCtrlNRealInc.init(
			xLetraControl,
			xrenglon,
			xtexto1,
			xtexto2,
			xCampo, xDecimales,
			xMinVal, xMaxVal, xDefVal, xFacVal,
			VariableControlada);
end;

procedure TCtrlNRealFac.Incrementar;
begin
	pvar^:= pvar^*IncVal;
	if pvar^>MaxVal then pvar^:=MaxVal;
	Pintar;
end;

procedure TCtrlNRealFac.Decrementar;
begin
	pvar^:= pvar^/IncVal;
	if pvar^<MinVal then pvar^:=MinVal;
	Pintar;
end;




constructor TCtrlNEntero.Init(
			xLetraControl: char;
			xrenglon: integer;
			xtexto1: string;
			xtexto2: string;
			xCampo: integer;
			xMinVal, xMaxVal, xDefVal, xIncVal: NEntero;
			var VariableControlada: NEntero	);
begin
	TCtrl.init(	xLetraControl,xrenglon,xtexto1,xtexto2,xCampo);
	MinVal:= xMinVal;
	MaxVal:= xMaxVal;
	DefVal:= xDefVal;
	IncVal:= xIncVal;
	pvar:= @VariableControlada;
end;

procedure TCtrlNEntero.Pintar;
var
	s: string;
	k: integer;
begin
	str( pvar^:Campo, s);
	s:= texto1+s+ texto2;
	writetxt( s);
end;

procedure TCtrlNEntero.Incrementar;
begin
	pvar^:= pvar^+IncVal;
	if pvar^>MaxVal then pvar^:=MaxVal;
	Pintar;
end;

procedure TCtrlNEntero.Decrementar;
begin
	pvar^:= pvar^-IncVal;
	if pvar^<MinVal then pvar^:=MinVal;
	Pintar;
end;

{
	Metodos del objeto TCtrlVerTexto
	que muestra una pantalla de tres lineas de texto
}

constructor TCtrlVerTexto.Init(
					xrenglon:integer;
					Texto_arriba,
					Texto_medio,
					Texto_abajo: string);
begin
   xrenglon:= xrenglon*3;
	SetFillStyle(bsSolid, GrisOscuro);  {.fondo gris.}
   ColorPapelTexto:= GrisOscuro;
	SetColor(14);
	Bar( MargenTexto-3,xRENGLON*AltoRenglon+MargenYSup-3, MargenTextoDer+3,(xRENGLON+3)*AltoRenglon+MargenYSup+3);
{	MARCO_DESNIVEL(496,xRENGLON*AltoRenglon+60-1, 626,xRENGLON*AltoRenglon+60+31,0,11);}
	OutTextXY( MargenTexto,xRENGLON*AltoRenglon+MargenYSup, texto_Arriba);
	OutTextXY( MargenTexto,(xRENGLON+1)*AltoRenglon+MargenYSup, texto_medio);
	OutTextXY( MargenTexto,(xRENGLON+2)*AltoRenglon+MargenYSup, texto_abajo);
end;

procedure TCtrlVerTexto.WriteTxt( texto: string );
begin
end;

procedure TCtrlVerTexto.Pintar;
begin
end;

{
Metodos de tctrlVer2Var. para mostrar el valor de 2 variables reales
}

constructor TCtrlVer2Var.Init(
			xrenglon: integer;
			xtexto11: string;
			xtexto12: string;
			xDecimales1: integer;
			var Variable1: NReal;
			xtexto21: string;
			xtexto22: string;
			xDecimales2: integer;
			var Variable2: NReal);
	 begin
   xrenglon:= 3* xrenglon;
	 pvar1:=@variable1;
	 pvar2:=@variable2;
	 texto1:=xtexto11;
	 texto2:=xtexto12;
	 texto3:=xtexto21;
	 texto4:=xtexto22;
	 renglon:=xrenglon;
	 decimales1:=xdecimales1;
	 decimales2:=xdecimales2;
	 valor_mostrado1:=0;
	 valor_mostrado2:=0;

   nRenglones:= 2;
   CajaControl;
   CajaDisplay( 1, 8, 8, texto1, '', texto2, Negro, Amarillo, false );
   CajaDisplay( 2, 8, 8, texto3, '', texto4, Negro, Amarillo, false );

end;


procedure TCtrlVer2Var.ActuarOnKey( Letra: char );
var auxtexto:string;
begin

	if  valor_mostrado1<> pvar1^ then
	begin
		valor_mostrado1:= pvar1^;
		str(pvar1^:6:decimales1,auxtexto);
      CajaDisplay( 1, 8, 8, '', auxtexto, '', Negro, Amarillo, true );
	end;

	if valor_mostrado2 <> pvar2^ then
	begin
		valor_mostrado2:= pvar2^;
		str(pvar2^:6:decimales2,auxtexto);
      CajaDisplay( 2, 8, 8, '', auxtexto, '', Negro, Amarillo, false );
 	end;

end;

procedure TCtrlVer2Var.WriteTxt( texto: string );
begin
end;

{
***************************************
Mtodos de TCtrlBoton
***************************************
***************************************
}

constructor TCtrlBoton.Init(
	nxx1,nyy1,nxx2,nyy2:integer;
	xtexto1: string;
	nxproc:ExtProc);
begin
	texto1:= xtexto1;
	xx1:=nxx1;
	yy1:=nyy1;
	xx2:=nxx2;
	yy2:=nyy2;

	apretado:=false;
	xproc:=nxproc;
	INSIGNIA(xx1,yy1,texto1,xx2-xx1,yy2-yy1); {primer PAINT}
end;


procedure TCtrlBoton.WriteTxt( texto: string );
begin
	{ para definir en los descendientes}
end;



procedure TCtrlBoton.Paint;
begin
	if Apretado then
	begin
			INSIGNIA_ON(xx1,yy1,texto1,xx2-xx1,yy2-yy1);
	end
	else
	begin
			INSIGNIA(xx1,yy1,texto1,xx2-xx1,yy2-yy1);
	end;
end;

procedure TCtrlBoton.ActuarOnMouse( MouseEvent: TMouseEvent );
begin
	Case MouseEvent of
	BotonIzqAbajo:
	begin
		if not Apretado then
		begin
			Apretado:= true;
			Paint;
		end;
	end;
	BotonIzqArriba:
	begin
		if Apretado then
		begin
			Apretado:= false;
			xproc;{ Modifica la varible }
			Paint;
		end;
	end;
	Abandono:
	begin
		if Apretado then
		begin
			Apretado:= false;
			Paint;
		end;
	end;
	end; {case}
end;


function TCtrlBoton.TocadoXY( x, y: integer ): boolean;
begin
	 if  (x>xx1-4) and (y>yy1) and (x<xx2) and  (y<yy2) THEN
		TocadoXY:= true
	 else		TocadoXY:= false;
end;


{
****************************************************************************
Mtodos de TCtrlBotonVar
***************************************
***************************************
}

constructor TCtrlBotonVar.Init(
		xrenglon:integer;
		xtexto1,
		xtexto2:string;
		xdeci:integer;
		xmin,
		xmax,
		xdef,
		xincr:NReal;
		var VariableControlada:NReal);
		var auxtexto1, auxtexto2:string;
begin
   xrenglon:= 3* xrenglon;
	texto1:= xtexto1;
	texto2:=xtexto2;
	pvar:=@VariableControlada;
	renglon:=xrenglon;
	boton:=0;	{inicial}

	deci:=xdeci;

	{fijar factor de unidades}
	{no se aceptan espacios en blanco para texto2}
   if length(texto2) > 0 then
   begin
     case texto2[1] of
     'M':	factor:=1e+6;
     'k':  factor:=1e+3;
     'K':  factor:=1e+3;
     'm':  factor:=1e-3;
     'u':  factor:=1e-6;
     'n':  factor:=1e-9;
     'p':  factor:=1e-12;
     else
        factor:=1;
     end;
   end
   else
      factor:= 1;

	min:=xmin;
	max:=xmax;
	def:=xdef;
	incr:=xincr;
	valor:=def;
	pvar^:=valor*factor;



	desplazamiento:=96+45; {constante}

	xx1:=MarGenTexto+2;
	yy1:=renglon*AltoRenglon+MargenYSup;
	xx2:=MarGenTextoDer-2;
	yy2:=(renglon+1)*AltoRenglon+MargenYSup;
	apretado:=false;




   nRenglones:= 2;
   CajaControl;
	str(min:4:0,auxtexto1);
	str(max:4:0,auxtexto2);
   CajaDisplay( 1, 6, 6, auxtexto1, texto1, auxtexto2, GrisOscuro, Negro, false );


	str(def:6:deci,auxtexto1);
   CajaDisplay( 2, 6, 6, '', auxtexto1, '', Negro, TablaColores[10], false );

   cajaInsignia( 2, 3, '<<');
   cajaInsignia( 2, 13, '>>' );
end;



procedure TCtrlBotonVar.WriteTxt( texto: string );
begin
{a definir en los descendientes}
end;


procedure TCtrlBotonVar.Paint;
begin
   wtraxp.ColorPapelTexto:= GrisClaro;

	if Apretado then
	begin
      case boton of
         0: cajaInsignia_ON( 2, 3, '<<');
         1: cajaInsignia_ON( 2, 13, '>>' );
      end;
	end
	else
	begin
      case boton of
         0: cajaInsignia( 2, 3, '<<');
         1: cajaInsignia( 2, 13, '>>' );
      end;
	end;
end;

procedure TCtrlBotonVar.ActuarOnMouse( MouseEvent: TMouseEvent );
begin
	Case MouseEvent of
	BotonIzqAbajo:
	begin
		if not Apretado then
		begin
			Apretado:= true;
			Paint;
		end;
	end;
	BotonIzqArriba:
	begin
		if Apretado then
		begin
			Apretado:= false;
			case boton of
			0: decrementar;
			1: incrementar;
			end; {case}
			Paint;
		end;
	end;
	Abandono:
	begin
		if Apretado then
		begin
			Apretado:= false;
			Paint;
		end;
	end;
	end; {case}
end;

function TCtrlBotonVar.TocadoXY( x, y: integer ): boolean;
begin
	 if  cajaInsigniaTocadoXY( 2, 3, '<<',x,y) THEN
	 begin
		TocadoXY:= true;
		boton:=0;
	 end
	 else
		if cajaInsigniaTocadoXY( 2, 13, '>>', x,y )
		then
		begin
			TocadoXY:= true;
			boton:=1;
		end
		else	TocadoXY:= false;
end;


procedure TCtrlBotonVar.incrementar;
var auxtexto:string;
begin
	valor:=valor+incr;
	if valor>max then begin
							beep;
							valor:=max;
							end;
	str(valor:6:deci,auxtexto);
   CajaDisplay( 2, 6, 6, '', auxtexto, '', Negro, TablaColores[10], true );
	pvar^:=valor*factor;
end;

procedure TCtrlBotonVar.decrementar;
var auxtexto:string;
begin
	valor:=valor-incr;
	if valor< min then begin
							 beep;
							 valor:=min;
							 end;

	str(valor:6:deci,auxtexto);
   CajaDisplay( 2, 6, 6, '', auxtexto, '', Negro, VerdeClaro, true );
	pvar^:=valor*factor;
end;


{
****************************************************************************
Mtodos de TCtrlBotonVar2
***************************************
***************************************
}

constructor TCtrlBotonVar2.Init(
		xrenglon:integer;
		xtexto1,
		xtexto2:string;
		xdeci:integer;
		var xmin, xmax:NReal;
		xdef,
		xincr:NReal;
		var VariableControlada:NReal);

begin
	pmin:=@xmin;
	pmax:=@xmax;
	TCtrlBotonVar.Init(
		xrenglon,
		xtexto1,
		xtexto2,
		xdeci,
		pmin^,
		pmax^,
		xdef,
		xincr,
		VariableControlada);
end;


procedure TCtrlBotonVar2.incrementar;
var auxtexto:string;
begin

	if pmin^<>min then
	begin
		min:=pmin^;

		SetFillStyle(bsSolid,7); {.pinto display.}
		Bar(MargenTExto-1,RENGLON*AltoRenglon+60+1, MargenTExto+28,RENGLON*AltoRenglon+73);

		SetLineStyle(psSolid,0,0);
      wtraxp.ColorPapelTexto:= tablacolores[0];
		SetColor(1);            {.pinto valores min, def, max.}
		str(min:4:0,auxtexto);
		OutTextXY( MargenTExto-1,renglon*AltoRenglon+60+1,auxtexto);
	end;

	if pmax^<>max then
	begin
		max:=pmax^;

		SetFillStyle(bsSolid,7); {.pinto display.}
		Bar(MargenTExto+95,RENGLON*AltoRenglon+60+1, MargenTExto+121,RENGLON*AltoRenglon+73);

		SetLineStyle(psSolid,0,0);
      wtraxp.ColorPapelTexto:= tablacolores[0];
		SetColor(1);            {.pinto valores min, def, max.}
		str(max:4:0,auxtexto);
		OutTextXY( MargenTExto+95,renglon*AltoRenglon+60+1,auxtexto);
	end;

	valor:=pvar^/factor;
	valor:=valor+incr;

	if valor>max then begin
                     beep;
							valor:=max;
							end;

	SetTextStyle(Fonts[2],0,xFontSize);
	SetFillStyle(bsSolid,0);
	Bar(MargenTExto+30,RENGLON*AltoRenglon+77, MargenTExto+72,RENGLON*AltoRenglon+86);
	SetColor(10);
	str(valor:6:deci,auxtexto);
	OutTextXY( MargenTExto+33,renglon*AltoRenglon+60+15,auxtexto);
	OutTextXY( MargenTExto+75,RENGLON*AltoRenglon+60+15, TEXTO2);

	pvar^:=valor*factor;
end;

procedure TCtrlBotonVar2.decrementar;
var auxtexto:string;
begin

	if pmin^<>min then
	begin
		min:=pmin^;

		SetFillStyle(bsSolid,7); {.pinto display.}
		Bar(MargenTExto-1,RENGLON*AltoRenglon+60+1, MargenTExto+28,RENGLON*AltoRenglon+73);

		SetLineStyle(psSolid,0,0);
		SetColor(1);            {.pinto valores min, def, max.}
		str(min:4:0,auxtexto);
      wtraxp.ColorPapelTexto:= tablacolores[0];
		OutTextXY( MargenTExto-1,renglon*AltoRenglon+60+1,auxtexto);
	end;

	if pmax^<>max then
	begin
		max:=pmax^;

		SetFillStyle(bsSolid,7); {.pinto display.}
		Bar(MargenTExto+95,RENGLON*AltoRenglon+60+1, MargenTExto+121,RENGLON*AltoRenglon+73);
      wtraxp.ColorPapelTexto:= tablacolores[0];
		SetLineStyle(psSolid,0,0);
		SetColor(1);            {.pinto valores min, def, max.}
		str(max:4:0,auxtexto);
		OutTextXY( MargenTExto+95,renglon*AltoRenglon+60+1,auxtexto);
	end;

	valor:=pvar^/factor;
	valor:=valor-incr;

	if valor< min then begin
							 beep;
							 valor:=min;
							 end;

	SetTextStyle(Fonts[2],0,xFontSize);
	SetFillStyle(bsSolid,0);
	Bar(MargenTExto+30,RENGLON*AltoRenglon+77, MargenTExto+70,RENGLON*AltoRenglon+86);

	SetColor(10);
	str(valor:6:deci,auxtexto);
	OutTextXY( MargenTExto+33,renglon*AltoRenglon+60+15,auxtexto);
	OutTextXY( MargenTExto+75,RENGLON*AltoRenglon+60+15, TEXTO2);

	pvar^:=valor*factor;
end;

procedure TCtrlBotonVar2.ActuarOnKey( Letra: char );
var auxtexto:string;
begin

	if pmin^<>min then
	begin
		min:=pmin^;

		SetFillStyle(bsSolid,7); {.pinto display.}
		Bar(MargenTExto-1,RENGLON*AltoRenglon+60+1, MargenTExto+28,RENGLON*AltoRenglon+73);

		SetLineStyle(psSolid,0,0);
		SetColor(1);            {.pinto valores min, def, max.}
		str(min:4:0,auxtexto);
		OutTextXY( MargenTExto-1,renglon*AltoRenglon+60+1,auxtexto);
	end;

	if pmax^<>max then
	begin
		max:=pmax^;

		SetFillStyle(bsSolid,7); {.pinto display.}
		Bar(MargenTExto+5,RENGLON*AltoRenglon+60+1, MargenTExto+121,RENGLON*AltoRenglon+73);

		SetLineStyle(psSolid,0,0);
		SetColor(1);            {.pinto valores min, def, max.}
		str(max:4:0,auxtexto);
		OutTextXY( MargenTExto+5,renglon*AltoRenglon+60+1,auxtexto);
	end;

	if  (valor*factor)<> pvar^ then
	begin
		valor:= pvar^/factor;
		SetTextStyle(Fonts[2],0,xFontSize);
		SetFillStyle(bsSolid,0);
		Bar(MargenTExto+30,RENGLON*AltoRenglon+77, MargenTExto+72,RENGLON*AltoRenglon+86);
		SetColor(7);
		str(valor:6:deci,auxtexto);
		OutTextXY( MargenTExto+33,renglon*AltoRenglon+60+15,auxtexto);
		OutTextXY( MargenTExto+75,RENGLON*AltoRenglon+60+15, TEXTO2);
	end;
end;


(******************************************************)
(*    PcrtlBotonProc                                  *)
(******************************************************)

constructor TCtrlBotonProc.Init(
			xrenglon:integer;
			xtexto1: string;
			nxproc:ExtProc);
		var auxtexto:string;
begin
	texto1:= xtexto1;
	renglon:=xrenglon;
	TCtrlBoton.init(MargenTExto-3,RENGLON*AltoRenglon+60, MargenTExto+123,RENGLON*AltoRenglon+60+30,xtexto1,nxproc);
end;


{ Mtodos de TControles }


constructor TControles.Init;
begin
   cc:= TList.Create;
end;

procedure TControles.ActuarOnKey( letra: char);
var
   k: integer;
begin
   for k:= 0 to cc.Count-1 do
      TCtrl(cc.Items[k]^).ActuarOnKey(letra);
end;

function TControles.PTocadoXY(x, y: integer ): PCtrl;
var
	buscando: boolean;
	k: integer;
begin
	buscando:= true;
	k:= 0;
	while buscando and (k < cc.Count) do
	begin
		if PCtrl(cc.items[k])^.TocadoXY(x,y) then
			buscando:= false
		else
			inc(k);
	end;

	if not buscando then
		PTocadoXY:= cc.items[k]
	else
		PTocadoXY:= nil;
end;


procedure TControles.ActuarOnMouse(x, y: integer; Evento: TMouseEvent );
begin
	if PActivo = nil then
	begin
		PActivo:= PTocadoXY(X, Y);
		if PActivo <> nil then
		begin
			PActivo^.ActuarOnMouse( Arrivo );
			PActivo^.ActuarOnMouse( Evento );
		end;
	end
	else
		if not PActivo^.TocadoXY(x,y) then
		begin
			PActivo^.ActuarOnMouse( Abandono );
			PActivo:= PTocadoXY(X, Y);
			if PActivo <> nil then
			begin
				PActivo^.ActuarOnMouse( Arrivo );
				PActivo^.ActuarOnMouse( Evento );
			end;
		end
		else PActivo^.ActuarOnMouse( Evento );
end;


procedure WriteCartel;
var
	vp:ViewPortType;
	t:TextSettingsType;
	x1, x2, y1, y2: integer;
	OldColor: word;
	texto: string;
begin
//   UTW:=8;
	GetTextSettings(t);
	SetTextStyle(Fonts[2], HorizDir,xFontSize);
	SetTextJustify(just_izquierda, just_abajo);
	texto:= 'SiMEEP (c)rch 1988-2003.';
	x1:= MargenTexto -5;
	x2:= x1+TextWidth( texto );
	y1:= GetMaxY-4*TextHeight('H');
	y2:= y1-TextHeight('H');

	GetViewSettings(vp);
	SetViewPort(x1, y2, x2, y1, true);
	ClearViewPort;
	with vp do  SetViewPort(x1,y1,x2,y2, true);

	OldColor:= GetColor;
	SetColor( ColorTexto );
	SetTextStyle(Fonts[1], t.Direction,t.CharSize);
	SetTextJustify(t.Horiz,t.Vert);
	OutTextXY( x1, y1, texto);
	SetColor( OldColor);

	SetTextStyle(t.font,t.Direction,t.CharSize);
	SetTextJustify(t.Horiz,t.Vert);
end;




procedure TControles.Pintar;
var
	OldColor: word;
   k: integer;
begin
   for k:= 0 to cc.count-1 do
   	TCtrl(cc.items[k]^).Pintar;

	OldColor:= GetColor;
{	SetColor( Rojo );
	rectangle( GetMaxY+10, 1, GetMaxX-1, GetMaxY-1);
	rectangle( GetMaxY+8, 1, GetMaxX-1, GetMaxY-1);
	rectangle( GetMaxY+6, 1, GetMaxX-1, GetMaxY-1);}
	WriteCartel;
	SetColor( OldColor );
end;



constructor TCtrlTexto.Init(
			xrenglon: integer;
			xtexto1: string);
begin
	TCtrl.Init('l', xrenglon, xtexto1, '', 0);
end;


procedure TCtrlTexto.WriteTxt( texto: string );
var
	vp:ViewPortType;
	t:TextSettingsType;
	x1, x2, y1, y2: integer;
	OldColor: word;
begin

	GetTextSettings(t);
	SetTextStyle(t.font,HorizDir,t.CharSize);
	SetTextJustify( just_izquierda, just_abajo);

	x1:= GetMaxY+TextWidth('M')*3;
	x2:= x1+TextWidth( texto );
	y1:= trunc((renglon*interlineado)*TextHeight('H'));
	y2:= y1-TextHeight('H');

	GetViewSettings(vp);
	SetViewPort(x1, y2, x2, y1, true);
	ClearViewPort;
	with vp do  SetViewPort(x1,y1,x2,y2, true);

	OldColor:= GetColor;
	SetColor( ColorTexto );
	OutTextXY( x1, y1, texto);
	SetColor( OldColor);

	SetTextStyle(t.font,t.Direction,t.CharSize);
	SetTextJustify(t.Horiz,t.Vert);
end;



constructor TCtrlBoolean.Init(
				xLetra: char;
				xrenglon: integer;
				xtexto1: string;
				var xvar: boolean );
begin
	TCtrl.Init(xLetra, xRenglon, xTexto1, '', 0);
	pvar:= @xvar;
end;

procedure TCtrlBoolean.Pintar;
var
	s: string;
begin
	if pvar^ then s:= texto1+' SI'
	else s:= texto1+' NO';
	WriteTXT( s);
end;


procedure TCtrlBoolean.Incrementar;
begin
	pvar^:= true;
	pintar;
end;

procedure TCtrlBoolean.Decrementar;
begin
	pvar^:= false;
	pintar;
end;



constructor TCtrlToggle.Init(
				xLetra: char;
				xrenglon: integer;
				xtexto1: string;
				var xvar: boolean );
begin
	TCtrlBoolean.Init(xLetra, xRenglon, xTexto1, xvar);
end;


procedure TCtrlToggle.Incrementar;
begin
	Decrementar;
end;

procedure TCtrlToggle.Decrementar;
begin
	pvar^:= not pvar^;
	pintar;
end;





constructor TCtrlProcedure.Init(
				xLetra: char;
				xrenglon: integer;
				xtexto1: string;
				xproc: ExtProc );
begin
	TCtrl.Init(xLetra, xRenglon, xTexto1, '', 0);
	proc:= xproc;
end;

procedure TCtrlProcedure.Pintar;
begin
	WriteTXT( texto1);
end;


procedure TCtrlProcedure.Incrementar;
begin
	proc;
end;

procedure TCtrlProcedure.Decrementar;
begin
	proc;
end;






constructor TDsplyNReal.Init(
			xrenglon: integer;
			xtexto1: string;
			xtexto2: string;
			xCampo, xDecimales: integer;
			var VariableControlada: NReal	);
begin
	TCtrl.init(	'l',xrenglon,xtexto1,xtexto2,xCampo);
	decimales:= xdecimales;
	pvar:= @VariableControlada;
	defval:= pvar^;
end;


procedure TDsplyNReal.ActuarOnKey( Letra: char );
begin
	if defval <> pvar^ then
	begin
		defval:= pvar^;
		pintar;
	end;
end;







constructor TDsplyNEntero.Init(
			xrenglon: integer;
			xtexto1: string;
			xtexto2: string;
			xCampo: integer;
			var VariableControlada: NEntero	);
begin
	TCtrl.init(	'l',xrenglon,xtexto1,xtexto2,xCampo);
	pvar:= @VariableControlada;
	defval:= pvar^;
end;


procedure TDsplyNEntero.ActuarOnKey( Letra: char );
begin
	if defval <> pvar^ then
	begin
		defval:= pvar^;
		pintar;
	end;
end;


procedure TDsplyNEntero.WriteTxt( texto: string );
var
	vp:ViewPortType;
	t:TextSettingsType;
	x1, x2, y1, y2: integer;
	OldColor: word;
begin
	Texto:= texto;
	GetTextSettings(t);
	SetTextStyle(t.font,HorizDir,t.CharSize);
	SetTextJustify(just_izquierda, just_abajo);

	x1:= GetMaxY+TextWidth('M')*3;
	x2:= x1+TextWidth( texto );
	y1:= trunc((renglon*interlineado)*TextHeight('H'));
	y2:= y1-TextHeight('H');

	GetViewSettings(vp);
	SetViewPort(x1, y2, x2, y1, true);
	ClearViewPort;
	with vp do  SetViewPort(x1,y1,x2,y2, true);
	OldColor:= GetColor;
	SetColor( ColorTexto );
	OutTextXY( x1, y1, texto);
	SetColor( OldColor);
	SetTextStyle(t.font,t.Direction,t.CharSize);
	SetTextJustify(t.Horiz,t.Vert);
end;

procedure TDsplyNReal.WriteTxt( texto: string );
var
	vp:ViewPortType;
	t:TextSettingsType;
	x1, x2, y1, y2: integer;
	OldColor: word;
begin
	Texto:= texto;
	GetTextSettings(t);
	SetTextStyle(t.font,HorizDir,t.CharSize);
	SetTextJustify(just_izquierda, just_abajo);

	x1:= GetMaxY+TextWidth('M')*3;
	x2:= x1+TextWidth( texto );
	y1:= trunc((renglon*interlineado)*TextHeight('H'));
	y2:= y1-TextHeight('H');

	GetViewSettings(vp);
	SetViewPort(x1, y2, x2, y1, true);
	ClearViewPort;
	with vp do  SetViewPort(x1,y1,x2,y2, true);
	OldColor:= GetColor;
	SetColor( ColorTexto );
	OutTextXY( x1, y1, texto);
	SetColor( OldColor);
	SetTextStyle(t.font,t.Direction,t.CharSize);
	SetTextJustify(t.Horiz,t.Vert);
end;
begin
	xx:= 100;
	yy:=100;
	izquierda:= false;
	centro:= false;
	derecha:= false;
end.